'use strict';
goog.provide('Blockly.Blocks.AngleMotor_begin');
goog.require('Blockly.Blocks');

Blockly.Blocks.AngleMotor_begin.HUE = 172;

Blockly.Blocks.connectToDrone = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('programModel initial')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)


    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};

Blockly.Blocks.turn_on = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput()
        .appendField('switch is on right?')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
    this.setOutput(true, Number);	
	
  }
};
Blockly.Blocks.turn_off = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput()
        .appendField('switch is on left?')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
    this.setOutput(true, Number);	
	
  }
};


Blockly.Blocks.setLed = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('Let the LED')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("led_x")
        .appendField('x')
        .appendField(Blockly.ANGLE)
		
    this.appendValueInput("led_y")
        .appendField('(1~8) , y')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput("")
        .appendField('(1~8) lit')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};

Blockly.Blocks.setLedLine = {
  init: function() {
	  var led_count = 
		[[Blockly.LED1,'1'],
		 [Blockly.LED2,'2'],		
		 [Blockly.LED3,'3'],		
		 [Blockly.LED4,'4'],		
		 [Blockly.LED5,'5'],		
		 [Blockly.LED6,'6'],		
		 [Blockly.LED7,'7'],		
		 [Blockly.LED8,'8'],		
		];
    this.setColour(Blockly.Blocks.pins.HUE);

    this.appendValueInput("setLed")
        .appendField('Let the ')
        .appendField(Blockly.ANGLE);

    this.appendDummyInput("")
        .appendField('(1~8) line LED lit as')
        .appendField(Blockly.ANGLE);
		
    this.appendValueInput("led_1")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_2")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_3")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_4")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_5")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_6")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_7")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendValueInput("led_8")
        .appendField('')
        .appendField(Blockly.ANGLE);
    this.appendDummyInput("")
        .appendField('(1 for lit,0 for off)')
        .appendField(Blockly.ANGLE);

		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};

Blockly.Blocks.motorControl = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendValueInput("whichMotor")
        .appendField('Let the motor ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("Speed")
        .appendField('(1~4) rotate with speed')
        .appendField(Blockly.ANGLE)
		
    this.appendDummyInput("")
        .appendField('(0~1000)')
        .appendField(Blockly.ANGLE)
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};

Blockly.Blocks.getChannel = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendValueInput("whichChannel")
        .appendField('the value(0~1000) of ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
		
    this.appendDummyInput("")
        .appendField('(1~4) channel ')
        .appendField(Blockly.ANGLE)		
	
    this.setOutput(true, Number);	
	this.setInputsInline(true);	
  }
};

Blockly.Blocks.getRoll = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('the angle(-90~90) of roll ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
		

    this.setOutput(true, Number);	
	this.setInputsInline(true);	
  }
};


Blockly.Blocks.getPitch = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('the angle(-90~90) of pitch ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
		

    this.setOutput(true, Number);	
	this.setInputsInline(true);	
  }
};

Blockly.Blocks.getYaw = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('the angle(0~360) of yaw ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
		

    this.setOutput(true, Number);	
	this.setInputsInline(true);	
  }
};