
'use strict';
goog.provide('Blockly.Arduino.AngleMotor_begin');
goog.require('Blockly.Arduino')

Blockly.Arduino.connectToDrone = function() {
 Blockly.Arduino.definitions_['run'] = 'volatile int run;' + "\n";	
 Blockly.Arduino.definitions_['command'] = 'String command;' + "\n";
 Blockly.Arduino.definitions_['inchar'] = 'volatile char inchar;' + "\n";	
 Blockly.Arduino.definitions_['wait'] = 'volatile int wait;' + "\n";	
 Blockly.Arduino.definitions_['wait_alt'] = 'volatile int wait_alt;' + "\n";
 Blockly.Arduino.definitions_['roll_busy'] = 'volatile int roll_busy;' + "\n";	 
 Blockly.Arduino.definitions_['pitch_busy'] = 'volatile int pitch_busy;' + "\n";	
 Blockly.Arduino.definitions_['yaw_busy'] = 'volatile int yaw_busy;' + "\n";	
 Blockly.Arduino.definitions_['altitude_busy'] = 'volatile int altitude_busy;' + "\n";	 

 Blockly.Arduino.definitions_['LY0'] = 'volatile int LY0 = 3;' + "\n";	  
 Blockly.Arduino.definitions_['LY1'] = 'volatile int LY1 = 4;' + "\n";	  
 Blockly.Arduino.definitions_['LY2'] = 'volatile int LY2 = 5;' + "\n";	  
 Blockly.Arduino.definitions_['LY3'] = 'volatile int LY3 = 6;' + "\n";	  
 Blockly.Arduino.definitions_['LY4'] = 'volatile int LY4 = 7;' + "\n";	  
 Blockly.Arduino.definitions_['LY5'] = 'volatile int LY5 = 8;' + "\n";	  
 Blockly.Arduino.definitions_['LY6'] = 'volatile int LY6 = 9;' + "\n";	  
 Blockly.Arduino.definitions_['LY7'] = 'volatile int LY7 = 10;' + "\n";	   

 Blockly.Arduino.definitions_['LX0'] = 'volatile int LX0 = A0;' + "\n";	  
 Blockly.Arduino.definitions_['LX1'] = 'volatile int LX1 = A1;' + "\n";	 
 Blockly.Arduino.definitions_['LX2'] = 'volatile int LX2 = A2;' + "\n";	 
 Blockly.Arduino.definitions_['LX3'] = 'volatile int LX3 = A3;' + "\n";	 
 Blockly.Arduino.definitions_['LX4'] = 'volatile int LX4 = A4;' + "\n";	 
 Blockly.Arduino.definitions_['LX5'] = 'volatile int LX5 = A5;' + "\n";	 
 Blockly.Arduino.definitions_['LX6'] = 'volatile int LX6 = 11;' + "\n";	 
 Blockly.Arduino.definitions_['LX7'] = 'volatile int LX7 = 12;' + "\n";	 

  Blockly.Arduino.setups_['setup_output'] = 
  "  pinMode(A0, OUTPUT);\n"+ 
  "  pinMode(A1, OUTPUT);\n"+  
  "  pinMode(A2, OUTPUT);\n"+  
  "  pinMode(A3, OUTPUT);\n"+  
  "  pinMode(A4, OUTPUT);\n"+  
  "  pinMode(A5, OUTPUT);\n"+   
  "  pinMode(12, OUTPUT);\n" +   
  "  pinMode(11, OUTPUT);\n" +  
  "  pinMode(3, OUTPUT);\n" +   
  "  pinMode(4, OUTPUT);\n" +   
  "  pinMode(5, OUTPUT);\n" +   
  "  pinMode(6, OUTPUT);\n"+
  "  pinMode(7, OUTPUT);\n " + 
  "  pinMode(8, OUTPUT);\n"+
  "  pinMode(9, OUTPUT);\n"+ 
  "  pinMode(10, OUTPUT);\n"+
   "  wait = 1;\n" +   
  "  wait_alt = 1;\n" +  
  "  roll_busy = 0;\n" +   
  "  pitch_busy = 0;\n" +   
  "  yaw_busy = 0;\n" +   
  "  altitude_busy = 0;\n"+
  "  Serial.begin(115200);\n " + 
  "  Serial.println(" + '"' + "#" + '"'+ ");\n"+
  "  delay(200);\n"+
  "  digitalWrite(LY0,HIGH);\n"+
  "  digitalWrite(LY1,HIGH);\n"+
  "  digitalWrite(LY2,HIGH);\n"+
  "  digitalWrite(LY3,HIGH);\n"+
  "  digitalWrite(LY4,HIGH);\n"+
  "  digitalWrite(LY5,HIGH);\n"+
  "  digitalWrite(LY6,HIGH);\n"+
  "  digitalWrite(LY7,HIGH);\n"+
  
  "  digitalWrite(LX0,HIGH); \n"+
  "  digitalWrite(LX1,HIGH); \n"+
  "  digitalWrite(LX2,HIGH); \n"+
  "  digitalWrite(LX3,HIGH); \n"+
  "  digitalWrite(LX4,HIGH); \n"+
  "  digitalWrite(LX5,HIGH); \n"+
  "  digitalWrite(LX6,HIGH); \n"+
  "  digitalWrite(LX7,HIGH); \n";
  
  
  var code =  
  "while(Serial.available()>0){\n" + 
  "  inchar = Serial.read();\n" + 
  "  command = String(command) + String(inchar);\n" + 
  "  if(inchar == '" + "r'){\n" + 
  "    inchar = Serial.read();\n" + 
  "    if(inchar == '" + "u'){\n" +
  "      Serial.println(" + '"' + "getData" + '"'+ ");\n"+
  "      command = " + '"' + " " + '"'+ ";\n" +
  "      run = 1;\n" + 
  "    } else {\n" + 
  "      command = " + '"' + " " + '"'+ ";\n" +
  "    }\n" +
  "  }\n" + 
  "  else if(inchar == '" + "s'){\n" + 
  "    inchar = Serial.read();\n" + 
  "    if(inchar == '" + "t'){\n" +
  "      Serial.println(" + '"' + "getData" + '"'+ ");\n"+
  "      command = " + '"' + " " + '"'+ ";\n" +
  "      run = 0;\n" + 
  "    } else {\n" + 
  "      command = " + '"' + " " + '"'+ ";\n" +
  "    }\n" +
  "  }\n"+   
  "}\n";     
  return code;

};

Blockly.Arduino.turn_on = function() {

  var code =  "run == 1";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.turn_off = function() {

  var code =  "run == 0";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.setLed = function() {
  var led_x = Blockly.Arduino.valueToCode(this, 'led_x', Blockly.Arduino.ORDER_ATOMIC);
  var led_y = Blockly.Arduino.valueToCode(this, 'led_y', Blockly.Arduino.ORDER_ATOMIC);

 
Blockly.Arduino.definitions_['led'] = "void led(int x, int y) {\n" +
  "  x = x - 1;\n"+ 
  "  y = 7 - y + 1;\n"+ 
  "  x = (0X80>>x);\n"+ 
  "  y = (0X80>>y);\n"+ 
  "  digitalWrite(12,(y&0x7f));\n"+ 
  "  digitalWrite(11,(y&0xbf));\n"+ 

  "  digitalWrite(A5,(y&0xdf));\n"+ 

  "  digitalWrite(A4,(y&0xef));\n"+ 

  "  digitalWrite(A3,(y&0xf7));\n"+ 

  "  digitalWrite(A2,(y&0xfb));\n"+ 

  "  digitalWrite(A1,(y&0xfd));\n"+ 

  "  digitalWrite(A0,(y&0xfe));\n"+ 
  
  
  "  digitalWrite(3,(x&0x80));\n"+ 
  "  digitalWrite(4,(x&0x40));\n"+ 
  "  digitalWrite(5,(x&0x20));\n"+ 
  "  digitalWrite(6,(x&0x10));\n"+ 
  "  digitalWrite(7,(x&0x08));\n"+ 
  "  digitalWrite(8,(x&0x04));\n"+ 
  "  digitalWrite(9,(x&0x02));\n"+ 
  "  digitalWrite(10,(x&0x01));\n"+
  " }\n";

 var code =   "led(" + led_x + "," + led_y + ");\n"+
 "delay(2);\n";
  return code;

};


Blockly.Arduino.setLedLine = function() {
  var led_value;
  var setLed = Blockly.Arduino.valueToCode(this, 'setLed', Blockly.Arduino.ORDER_ATOMIC); 
  var led_1 = Blockly.Arduino.valueToCode(this, 'led_1', Blockly.Arduino.ORDER_ATOMIC);
  var led_2 = Blockly.Arduino.valueToCode(this, 'led_2', Blockly.Arduino.ORDER_ATOMIC);
  var led_3 = Blockly.Arduino.valueToCode(this, 'led_3', Blockly.Arduino.ORDER_ATOMIC);
  var led_4 = Blockly.Arduino.valueToCode(this, 'led_4', Blockly.Arduino.ORDER_ATOMIC);
  var led_5 = Blockly.Arduino.valueToCode(this, 'led_5', Blockly.Arduino.ORDER_ATOMIC);
  var led_6 = Blockly.Arduino.valueToCode(this, 'led_6', Blockly.Arduino.ORDER_ATOMIC);
  var led_7 = Blockly.Arduino.valueToCode(this, 'led_7', Blockly.Arduino.ORDER_ATOMIC);
  var led_8 = Blockly.Arduino.valueToCode(this, 'led_8', Blockly.Arduino.ORDER_ATOMIC);


  
  
  Blockly.Arduino.definitions_['SetMatrix'] = "void SetMatrix(unsigned char LX, unsigned char LY) {\n" +
  
  "  LX=~LX;  \n"+                     
  "  digitalWrite(LX7,LX&0x80);\n"+   
  "  digitalWrite(LX6,LX&0x40);\n"+   
  "  digitalWrite(LX5,LX&0x20);\n"+    
  "  digitalWrite(LX4,LX&0x10);\n"+  
  "  digitalWrite(LX3,LX&0x08);\n"+  
  "  digitalWrite(LX2,LX&0x04);\n"+   
  "  digitalWrite(LX1,LX&0x02);\n"+    
  "  digitalWrite(LX0,LX&0x01);\n"+   
                             
  "  digitalWrite(LY0,LY&0x80);\n"+
  "  digitalWrite(LY1,LY&0x40);\n"+
  "  digitalWrite(LY2,LY&0x20);\n"+
  "  digitalWrite(LY3,LY&0x10);\n"+
  "  digitalWrite(LY4,LY&0x08);\n"+
  "  digitalWrite(LY5,LY&0x04);\n"+
  "  digitalWrite(LY6,LY&0x02);\n"+
  "  digitalWrite(LY7,LY&0x01);\n"+
  "	}\n";  
  
  var code =  "SetMatrix(1<<("+setLed+"-1)"+","+ led_1 +"*(1<<7)+" +
                              led_2 +"*(1<<6)+" +
                              led_3 +"*(1<<5)+" +
                              led_4 +"*(1<<4)+" +
                              led_5 +"*(1<<3)+" +
                              led_6 +"*(1<<2)+" +
                              led_7 +"*(1<<1)+" +
                              led_8 +"*(1<<0)" +

							  ");\n"+
							  "delay(2);\n";

  return code; 
  
};


Blockly.Arduino.motorControl = function() {
  var whichMotor = Blockly.Arduino.valueToCode(this, 'whichMotor', Blockly.Arduino.ORDER_ATOMIC);
  var Speed = Blockly.Arduino.valueToCode(this, 'Speed', Blockly.Arduino.ORDER_ATOMIC);

 
Blockly.Arduino.definitions_['motorControl'] = "void motorControl(int whichMotor, int speed) {\n"+
  "  speed = speed + 1000;  \n"+
 "  Serial.print(" + '"' + "motor " + '"'+ ");\n"+ 
  "  Serial.print((whichMotor - 1));  \n"+
 "  Serial.print(" + '"' + " " + '"'+ ");\n"+   
  "  Serial.println(speed);  \n"+
  "  }\n";
 var code =   "motorControl(" + whichMotor + "," + Speed + ");\n";
  return code;

};




Blockly.Arduino.getChannel = function() {

 Blockly.Arduino.definitions_['done'] = 'volatile int done;' + "\n";	
 Blockly.Arduino.definitions_['Channel_l'] = 'volatile int Channel_l;' + "\n";
 Blockly.Arduino.definitions_['Channel_h'] = 'volatile int Channel_h;' + "\n";	
 Blockly.Arduino.definitions_['Channel'] = 'volatile int Channel;' + "\n";
 Blockly.Arduino.definitions_['key'] = 'volatile int key;' + "\n"; 

  var whichChannel = Blockly.Arduino.valueToCode(this, 'whichChannel', Blockly.Arduino.ORDER_ATOMIC);
 Blockly.Arduino.definitions_['getChannel'] = "int getChannel(int whichChannel){\n" +
  " while (done == 0) {\n"+
  " if (whichChannel == 1) {\n"+
  "  Serial.println(" + '"' + "getChannel1" + '"'+ ");\n"+   
  "  } else if (whichChannel == 2) {\n"+
  "  Serial.println(" + '"' + "getChannel2" + '"'+ ");\n"+   
  "  } else if (whichChannel == 3) {\n"+
  "  Serial.println(" + '"' + "getChannel3" + '"'+ ");\n"+   
  "  } else if (whichChannel == 4) {\n"+
  "  Serial.println(" + '"' + "getChannel4" + '"'+ ");\n"+   
  "  }\n"+
  "  while (Serial.available() > 0) {\n"+
  "    inchar = Serial.read();\n"+
  "    if (whichChannel == 1) {\n"+
  "      key = 'T';\n"+
  "    } else if (whichChannel == 2) {\n"+
  "      key = 'W';\n"+
  "    } else if (whichChannel == 3) {\n"+
  "      key = 'I';\n"+
  "    } else if (whichChannel == 4) {\n"+
  "      key = 'O';\n"+
  "    }\n"+
  "    if (inchar == key) {\n"+
  "      Channel_l = Serial.read();\n"+
  "      Channel_h = Serial.read();\n"+
  "      if (Serial.read() == '!') {\n"+
  "        Channel = Channel_l + Channel_h * 255;\n"+
  "        done = 1;\n"+
  "        if (Channel < 0) {\n"+
  "          Channel = Channel + 255;\n"+
  "        }\n"+
  "      }\n"+
  "    }\n"+
  "  }\n"+
  "  delay(5);\n"+
  "}\n"+
  "done = 0;\n"+
  "return Channel-1000;\n"+
  "}\n";

  var code =  "getChannel("+whichChannel+")";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};





Blockly.Arduino.getRoll = function() {
 Blockly.Arduino.definitions_['done'] = 'volatile int done;' + "\n";	
 Blockly.Arduino.definitions_['roll_l'] = 'volatile int roll_l;' + "\n";
 Blockly.Arduino.definitions_['roll_h'] = 'volatile int roll_h;' + "\n";	
 Blockly.Arduino.definitions_['roll'] = 'volatile int roll;' + "\n";
 Blockly.Arduino.definitions_['getRoll'] = "int getRoll(){\n" +
  " while (done == 0) {\n"+
  "  Serial.println(" + '"' + "getRoll" + '"'+ ");\n"+    
  "  while (Serial.available() > 0) {\n"+
  "    inchar = Serial.read();\n"+
  "    if (inchar == 'R') {\n"+
  "      roll_l = Serial.read();\n"+
  "      roll_h = Serial.read();\n"+
  "      if (Serial.read() == '!') {\n"+
  "        roll = roll_l + roll_h * 255;\n"+
  "        done = 1;\n"+
  "        if (roll < 0) {\n"+
  "          roll = roll + 255;\n"+
  "        }\n"+
  "      }\n"+
  "    }\n"+
  "  }\n"+
  "  delay(5);\n"+
  "}\n"+
  "done = 0;\n"+
  "return roll / 10;\n"+
  "}";

  var code =  "getRoll()";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.getPitch = function() {
 Blockly.Arduino.definitions_['done'] = 'volatile int done;' + "\n";	
 Blockly.Arduino.definitions_['pitch_l'] = 'volatile int pitch_l;' + "\n";
 Blockly.Arduino.definitions_['pitch_h'] = 'volatile int pitch_h;' + "\n";	
 Blockly.Arduino.definitions_['pitch'] = 'volatile int pitch;' + "\n";

 Blockly.Arduino.definitions_['getPitch'] = "int getPitch(){\n" +
  " while (done == 0) {\n"+
  "  Serial.println(" + '"' + "getPitch" + '"'+ ");\n"+    
  "  while (Serial.available() > 0) {\n"+
  "    inchar = Serial.read();\n"+
  "    if (inchar == 'P') {\n"+
  "      pitch_l = Serial.read();\n"+
  "      pitch_h = Serial.read();\n"+
  "      if (Serial.read() == '!') {\n"+
  "        pitch = pitch_l + pitch_h * 255;\n"+
  "        done = 1;\n"+
  "        if (pitch < 0) {\n"+
  "          pitch = pitch + 255;\n"+
  "        }\n"+
  "      }\n"+
  "    }\n"+
  "  }\n"+
  "  delay(5);\n"+
  "}\n"+
  "done = 0;\n"+
  "return pitch / 10;\n"+
  "}";

  var code =  "getPitch()";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.getYaw = function() {
 Blockly.Arduino.definitions_['done'] = 'volatile int done;' + "\n";	
 Blockly.Arduino.definitions_['yaw_l'] = 'volatile int yaw_l;' + "\n";
 Blockly.Arduino.definitions_['yaw_h'] = 'volatile int yaw_h;' + "\n";	
 Blockly.Arduino.definitions_['yaw'] = 'volatile int yaw;' + "\n";

 Blockly.Arduino.definitions_['getYaw'] = "int getYaw(){\n" +
  " while (done == 0) {\n"+
  "  Serial.println(" + '"' + "getYaw" + '"'+ ");\n"+    
  "  while (Serial.available() > 0) {\n"+
  "    inchar = Serial.read();\n"+
  "    if (inchar == 'Y') {\n"+
  "      yaw_l = Serial.read();\n"+
  "      yaw_h = Serial.read();\n"+
  "      if (Serial.read() == '!') {\n"+
  "        yaw = yaw_l + yaw_h * 255;\n"+
  "        done = 1;\n"+
  "        if (yaw < 0) {\n"+
  "          yaw = yaw + 255;\n"+
  "        }\n"+
  "      }\n"+
  "    }\n"+
  "  }\n"+
  "  delay(5);\n"+
  "}\n"+
  "done = 0;\n"+
  "return yaw / 10;\n"+
  "}";

  var code =  "getYaw()";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};


