'use strict';
goog.provide('Blockly.Blocks.AngleMotor_begin');
goog.require('Blockly.Blocks');

Blockly.Blocks.AngleMotor_begin.HUE = 172;

Blockly.Blocks.flyStart = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('take off')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)


    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
  }
};

Blockly.Blocks.flyStop = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('fly stop')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)


    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
  }
};


Blockly.Blocks.land = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('land')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)


    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
  }
};

Blockly.Blocks.setAltitude = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('set alitude ')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('to')
        .appendField(Blockly.ANGLE)
    this.appendDummyInput()
        .appendField('(0~300) cm')	
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};


Blockly.Blocks.flyForward = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('fly')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('forward')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput()
        .appendField('(0~300) cm')
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};
Blockly.Blocks.flyBackward = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('fly')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('backward')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput()
        .appendField('(0~300) cm')
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};


Blockly.Blocks.flyLeft = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('fly')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('left')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput()
        .appendField('(0~300) cm')		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};
Blockly.Blocks.flyRight = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('fly')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('right')
        .appendField(Blockly.ANGLE)
    this.appendDummyInput()
        .appendField('(0~300) cm')
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};

Blockly.Blocks.the_drone_is_busy = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput()
        .appendField('the drone is busy?')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)
    this.setOutput(true, Number);	
	
  }
};


Blockly.Blocks.yawLeft = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('yaw')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('left')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput()
        .appendField('(0~360) °')		
		
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};
Blockly.Blocks.yawRight = {
  init: function() {
    this.setColour(Blockly.Blocks.pins.HUE);
    this.appendDummyInput("")
        .appendField('yaw')
        .appendField(Blockly.ANGLEMOTOR_BEGIN)

    this.appendValueInput("angle")
        .appendField('right')
        .appendField(Blockly.ANGLE)

    this.appendDummyInput()
        .appendField('(0~360) °')			
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);

  }
};


