
'use strict';
goog.provide('Blockly.Arduino.AngleMotor_begin');
goog.require('Blockly.Arduino')

Blockly.Arduino.flyStart = function() {
  var code =  
  "Serial.println(" + '"' + "arm" + '"'+ ");\n" + 
  "delay(1000);\n" +
  "Serial.println(" + '"' + "flyStart" + '"'+ ");\n";
  return code;

};


Blockly.Arduino.flyStop = function() {
  var code =  
  "Serial.println(" + '"' + "flyStop" + '"'+ ");\n";
  return code;

};



Blockly.Arduino.land = function() {
  var code =  "Serial.println(" + '"' + "land" + '"'+ ");\n";
  return code;

};

Blockly.Arduino.setAltitude = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set z_dis = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "*0.7"  + ");\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();}\n" +
  "delay(50);\n";
  return code;

};


Blockly.Arduino.flyForward = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_ro_pi = " + '"'+ ");\n" + 
  "Serial.println(120);\n" + 
  "Serial.print(" + '"' + "set y_juli = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "*0.7"  + ");\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();\n" +
  "//delay(5);\n"+
  "}\n"+
  "delay(50);\n";
  return code;

};
Blockly.Arduino.flyBackward = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_ro_pi = " + '"'+ ");\n" + 
  "Serial.println(80);\n" + 
  "Serial.print(" + '"' + "set y_juli = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "*0.7"  + ");\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();\n" +
  "//delay(5);\n"+
  "}\n"+
  "delay(50);\n";
  return code;

};

Blockly.Arduino.flyLeft = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_fo_ba = " + '"'+ ");\n" + 
  "Serial.println(80);\n" + 
  "Serial.print(" + '"' + "set x_distance = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "*0.7"  + ");\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();\n" +
  "delay(50);}\n";
  return code;

};
Blockly.Arduino.flyRight = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_fo_ba = " + '"'+ ");\n" + 
  "Serial.println(120);\n" + 
  "Serial.print(" + '"' + "set x_distance = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "*0.7"  + ");\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();\n" +
  "delay(50);}\n";
  return code;

};



Blockly.Arduino.the_drone_is_busy = function() {

 Blockly.Arduino.definitions_['is_busy'] = "int isBusy(){\n" +
  "  Serial.println(" + '"' + "getWait" + '"'+ ");\n"+ 
  "  while(Serial.available()>0){\n" + 
  "    wait = 1;\n" +   
  "    wait_alt = 1;\n" +     
  "    inchar = Serial.read();\n" + 
  "    if(inchar == '" + "W'){\n" + 
  "      roll_busy = Serial.read();\n" + 
  "      pitch_busy = Serial.read();\n" + 
  "      yaw_busy = Serial.read();\n" +   
  "      altitude_busy = Serial.read();\n" +     
  "      if(Serial.read() == '" + "!'){\n" +
  "        if((roll_busy == 0 && pitch_busy == 0) && yaw_busy == 0){\n" +
  "          wait = 0;\n" + 
  "        } else {\n" + 
  "          wait = 1;\n" +
  "        }\n" +
  "        if(altitude_busy == 0){\n" +  
  "          wait_alt = 1;\n" +  
  "        } else {\n" + 
  "          wait_alt = 0;\n" +
  "        }\n" + 
  "      }else{\n" + 
  "        wait_alt = 1;\n" +
  "      }\n" +  
  "    }else{\n" + 
  "      wait_alt = 1;\n" +
  "    }\n" +    
  "    if(wait == 1 || wait_alt == 1){\n" + 
  "      wait = 1;\n" +
  "    } else {\n"+ 
  "    wait = 0;\n" +  
  "    }\n"+ 
  "  }\n"+
  "delay(5);\n"+
  "return wait;\n"+  
  "}\n";
  var code =  "isBusy()";

  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.yawLeft = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_up_down = " + '"'+ ");\n" + 
  "Serial.println(" + "100-" + distance + "/ 2 );\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();}\n" +
  "delay(50);\n";
  return code;

};
Blockly.Arduino.yawRight = function() {
  var distance = Blockly.Arduino.valueToCode(this, 'angle', Blockly.Arduino.ORDER_ATOMIC);
  var code =  
  "Serial.print(" + '"' + "set fly_up_down = " + '"'+ ");\n" + 
  "Serial.println(" + distance + "/2"  + "+100);\n"+
  "delay(1);\n" +
  "while(Serial.available()>0){\n" + 
  "inchar = Serial.read();}\n" +
  "delay(50);\n";
  return code;

};
